<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  
  <link rel="shortcut icon" href="../img/favicon.ico">
  <title>Authentication - hardtofind</title>
  <link href='https://fonts.googleapis.com/css?family=Lato:400,700|Roboto+Slab:400,700|Inconsolata:400,700' rel='stylesheet' type='text/css'>

  <link rel="stylesheet" href="../css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../css/theme_extra.css" type="text/css" />
  <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css">
  
  <script>
    // Current page data
    var mkdocs_page_name = "Authentication";
    var mkdocs_page_input_path = "authentication.md";
    var mkdocs_page_url = null;
  </script>
  
  <script src="../js/jquery-2.1.1.min.js" defer></script>
  <script src="../js/modernizr-2.8.3.min.js" defer></script>
  <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
  <script>hljs.initHighlightingOnLoad();</script> 
  
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
      <div class="wy-side-nav-search">
        <a href=".." class="icon icon-home"> hardtofind</a>
        <div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
	<ul class="current">
	  
          
            <li class="toctree-l1">
		
    <a class="" href="../introduction/">Introduction</a>
	    </li>
          
            <li class="toctree-l1 current">
		
    <a class="current" href="./">Authentication</a>
    <ul class="subnav">
            
    <li class="toctree-l2"><a href="#authentication">Authentication</a></li>
    
        <ul>
        
            <li><a class="toctree-l3" href="#post-authenticate">POST /authenticate</a></li>
        
            <li><a class="toctree-l3" href="#get-info">GET /info</a></li>
        
        </ul>
    

    </ul>
	    </li>
          
            <li class="toctree-l1">
		
    <a class="" href="../general/">General Usage</a>
	    </li>
          
            <li class="toctree-l1">
		
    <a class="" href="../batch/">Batch Operations</a>
	    </li>
          
            <li class="toctree-l1">
		
    <a class="" href="../order-management/">Order Management</a>
	    </li>
          
            <li class="toctree-l1">
		
    <a class="" href="../giftcards/">Giftcards</a>
	    </li>
          
        </ul>
      </div>
      &nbsp;
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="..">hardtofind</a>
      </nav>

      
      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="..">Docs</a> &raquo;</li>
    
      
    
    <li>Authentication</li>
    <li class="wy-breadcrumbs-aside">
      
    </li>
  </ul>
  <hr/>
</div>
          <div role="main">
            <div class="section">
              
                <h1 id="authentication">Authentication</h1>
<p>The API uses <a href="https://jwt.io/">JSON Web Tokens</a> for authentication where necessary.
For the rest of this documentation we refer to these as JWT's.
To obtain a JWT use the <code>/authenticate</code> endpoint.</p>
<p>Tokens are issued for a lifetime of 15 minutes which should be enough to undertake any action via the API.
We may implement long lived tokens based on feedback, but as this is carries an inherent security risk, we require
re-authentication with each set of actions.</p>
<p>API requests expect for the API token to be included in all API requests to the server in an <code>X-Auth-Token</code> header as follows:</p>
<p><code>X-Auth-Token: &lt;your_jwt&gt;</code></p>
<aside class="notice">
You must replace <code>your_jwt</code> with your personal API key.
</aside>

<h2 id="post-authenticate">POST /authenticate</h2>
<p>To obtain a JWT you need to POST your username and password to this endpoint with the structure as outlined here.</p>
<p>The JWT is valid for a period of 15 minutes from the time of issue which should be sufficient to undertake any operations
using the API while minimising security risks.</p>
<p>Note: the username and password belong to the store owner. There is currently a limitation of one user account per store.</p>
<pre><code class="json">{
  &quot;username&quot;: &quot;&lt;your_username&gt;&quot;,
  &quot;password&quot;: &quot;&lt;your_password&gt;&quot;
}
</code></pre>

<blockquote>
<p>If the supplied credentials are valid the above command returns a JSON response with the JWT as outlined below:</p>
</blockquote>
<pre><code class="json">{
  &quot;person&quot;: {
    &quot;id&quot;: &quot;&lt;your_id&gt;&quot;,
    &quot;role&quot;: &quot;&lt;your_role&gt;&quot;
  },
  &quot;token&quot;: &quot;&lt;your_jwt&gt;&quot;
}
</code></pre>

<h2 id="get-info">GET /info</h2>
<p>Once you have a JWT you can check its contents using the <code>/info</code> endpoint. It will return the details as outlined here:</p>
<pre><code class="json">{
    &quot;user_id&quot;: 111,
    &quot;seller_account_id&quot;: 222,
    &quot;created&quot;: &quot;&lt;created_date&gt;&quot;,
    &quot;expires&quot;: &quot;&lt;expiry_date&gt;&quot;,
    &quot;roles&quot;: [
        &quot;&lt;your_role&gt;&quot;,
        &quot;&lt;your_other_role&gt;&quot;
    ]
}
</code></pre>
              
            </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../general/" class="btn btn-neutral float-right" title="General Usage">Next <span class="icon icon-circle-arrow-right"></span></a>
      
      
        <a href="../introduction/" class="btn btn-neutral" title="Introduction"><span class="icon icon-circle-arrow-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
    
  </div>

  Built with <a href="http://www.mkdocs.org">MkDocs</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
      
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" style="cursor: pointer">
    <span class="rst-current-version" data-toggle="rst-current-version">
      
      
        <span><a href="../introduction/" style="color: #fcfcfc;">&laquo; Previous</a></span>
      
      
        <span style="margin-left: 15px"><a href="../general/" style="color: #fcfcfc">Next &raquo;</a></span>
      
    </span>
</div>
    <script>var base_url = '..';</script>
    <script src="../js/theme.js" defer></script>
      <script src="../search/main.js" defer></script>

</body>
</html>
